﻿//DESCRIPTION: Which font is it? 

/*
		+ Indesign Version: CS5.5 und 6
		+ Autor: Roland Dreger
		+ Datum: 4. November 2014
		
		+ Zuletzt aktualisiert: 5. November 2023
		
		+ Das vorliegende Skript listet auswaehlte Eigenschaften der Textabschnitte/Absaetze/Formatbereiche/Einfuegemarke 
			im aktiven Dokument auf. Diese Eigenschaften werden in einem Textrahmen auf einer neuen Ebene eingefügt. 
			Die jeweilige Stelle wird mit einem Pfeil markiert.
			
			Hinweis zu Hintergrundfarbe und Kontur: 
			Die Farben der eingefuegten Textrahmen koennen geaendert werden. 
			a) In der InDesign-Farbpalette des aktiven Dokumentes die gewuenschten Farben 
				 an die 3. Position (Hintergrund) bzw. 4. Position (Kontur) ziehen.
			b) Über den Button »Setup« -> Dropdown-Menues
			
			Hinweis zum Absatz- und Objektformaten:
			a) Den Absaetzen im eingefuegten Textrahmen wird jeweils das Standardformat [Einf. Absatz] zugewiesen. 
			b) Über den Button »Setup« -> »Formate für Schriftbox« koennen den Absaetzen, dem Textrahmen und dem Pfeil
				 vordefinierte Formate zugewiesen werden.

			Wichtig:
			Nicht untersucht werden Bereiche auf der Montageflaeche und auf Pfaden. 
			
			
			
			LIZENZ: 
		
		+ Freies Script fuer private und kommerzielle Nutzung (Creative Commons Lizenz: Roland Dreger, CC BY SA 3.0 AT). 
		+ Verwendung auf eigene Gefahr.
		
		+ Free Script for private and commercial use (Creative Commons Licence: Roland Dreger, CC BY SA 3.0 AT). 
		+ Use at your own risk.
		

		
			KONTAKT:
			
			mail{at}rolanddreger.net
*/

//@targetengine "appliedFontsSession";

var _global = {};


app.doScript(main, ScriptLanguage.JAVASCRIPT , [], UndoModes.ENTIRE_SCRIPT, "Which font is it?");


function main () {
	
	if(!_global) { 
		return false; 
	}
	
	var _fillColorName;
	var _strokeColorName;
	var _boxStylesCheckbox;
	var _setupButton;
	var _startButton;
	var _stopInfo;
	
	/* Deutsch-Englische Dialogtexte definieren */
	__defLocalizeStrings();
	
	
	var _ui = appliedFontPalette ();
	_ui.show();


	function appliedFontPalette () {

		var _win = new Window ("palette", localize(_global.dialogTitle), undefined, { borderless: false, closeButton: true });
		with (_win) {
			margins = [10,5,10,15];
			spacing = 10;
			alignChildren = ["fill", "fill"];
			var _rangesGroup = add("group");
			with (_rangesGroup) {
				orientation = "column";
				spacing = 5;
				margins = [0,5,0,0];
				alignChildren = ["fill","fill"];
				var _look = add ("statictext", undefined, localize(_global.rangePaletteLabel));
				with (_look) {
					justify = "center";
				}
				var _ranges = add ("panel");
				with (_ranges) {
					alignChildren = "left";
					spacing = 3;
					margins = [10,10,15,13];
					var _radioIP = add ("radiobutton", undefined, localize(_global.insertionPointsRadiobuttonLabel));			
					_radioIP.id = "insertionPoints";
					_radioIP.value = true;
					var _radioStory = add ("radiobutton", undefined, localize(_global.storiesRadiobuttonLabel));
					_radioStory.id = "stories";
					var _radioParagraph = add ("radiobutton", undefined, localize(_global.paragraphsRadiobuttonLabel));
					_radioParagraph.id = "paragraphs";
					var _radioTSR = add ("radiobutton", undefined, localize(_global.textStyleRangesRadiobuttonLabel));
					_radioTSR.id = "textStyleRanges";
				} // END _ranges panel	 
			} // END _rangesGroup 
			var _propsGroup = add("group");
			with (_propsGroup) {
				orientation = "column";
				spacing = 5;
				margins = [0,0,0,0];
				alignChildren = ["fill","fill"];
				var _properties = add ("statictext", undefined, localize(_global.propertiesPaletteLabel));
				with (_properties) {
					justify = "center";
				}
				var _props = add ("panel");
				with (_props) {
					alignChildren = "left";
					spacing = 2;
					margins = [10,10,15,13];
					var _checkName = add ("checkbox", undefined, localize(_global.fontNameCheckboxLabel));
					_checkName.id = "fontName";
					_checkName.value = true;
					var _checkFontStyle = add ("checkbox", undefined, localize(_global.fontStyleCheckboxLabel));
					_checkFontStyle.id = "fontStyle";
					var _checkFontType = add ("checkbox", undefined, localize(_global.fontTypeCheckboxLabel));
					_checkFontType.id = "fontType";
					var _checkFontSize = add ("checkbox", undefined, localize(_global.fontSizeCheckboxLabel));
					_checkFontSize.id = "fontSize";
					var _checkLeading = add ("checkbox", undefined, localize(_global.leadingCheckboxLabel));
					_checkLeading.id = "leading";
					var _checkCaps = add ("checkbox", undefined, localize(_global.capsCheckboxLabel));
					_checkCaps.id = "caps";
					var _checkKerning = add ("checkbox", undefined, localize(_global.kerningCheckboxLabel));
					_checkKerning.id = "kerning";
					var _checkTracking = add ("checkbox", undefined, localize(_global.trackingCheckboxLabel));
					_checkTracking.id = "tracking";
					var _checkHScale = add ("checkbox", undefined, localize(_global.hScaleCheckboxLabel));
					_checkHScale.id = "hScale";
					var _checkVScale = add ("checkbox", undefined, localize(_global.vScaleCheckboxLabel));
					_checkVScale.id = "vScale";
					var _checkSkew = add ("checkbox", undefined, localize(_global.skewCheckboxLabel));
					_checkSkew.id = "skew";
					var _checkNoBreak = add ("checkbox", undefined, localize(_global.noBreakCheckboxLabel));
					_checkNoBreak.id = "noBreak";
					var _checkColor = add ("checkbox", undefined, localize(_global.colorCheckboxLabel));
					_checkColor.id = "color";
					var _checkPStyle = add ("checkbox", undefined, localize(_global.pStyleCheckboxLabel));
					_checkPStyle.id = "pStyle";
					var _checkCStyle = add ("checkbox", undefined, localize(_global.cStyleCheckboxLabel));
					_checkCStyle.id = "cStyle";
					var _checkLanguage = add ("checkbox", undefined, localize(_global.languageCheckboxLabel));
					_checkLanguage.id = "language";
				} // END _props panel			 
			} // END _rangesGroup 
			var _buttonGroup = add("group");
			with(_buttonGroup) {
				orientation = "column";
				_setupButton = add("button", undefined, "Setup");
				with(_setupButton) {
					helpTip = "Choose Label Colors";
				} /* END _setupButton */
				var _colorNameGroup = add("group");
				with(_colorNameGroup) {
					size = [0,0];
					_fillColorName = add ("statictext", undefined, "");
					_strokeColorName = add ("statictext", undefined, "");
					_boxStylesCheckbox = add("checkbox", undefined, localize(_global.boxStyleCheckboxLabel));
				} /* END _colorNameGroup */
				_stopInfo = add ("statictext", undefined, localize(_global.escStopLabel));
				with(_stopInfo) {
					enabled = false;
				}
				_startButton = add ("button", undefined, localize(_global.startButtonLabel), { name: "ok" });
			} /* END _buttonGroup */
		} /* END _win window */


			// Callbacks
		_startButton.onClick = function() { 
					
			$.hiresTimer; // Aufruf setzt den Timer auf 0

			if (app.layoutWindows.length > 0 && app.documents.length > 0) {
				
				var _doc = app.activeDocument;

				var _selectedRange = 0;
				_selectedRange = selectedRange (_ranges);
				function selectedRange (_ranges) {
					for (var m = 0; m < _ranges.children.length; m++) {
						if (_ranges.children[m].value == true) {
							return m;
						}
					}
					return 0;
				} // END function selectedRange
				
				var _selectedProps = [];
				_selectedProps = selectedProps (_props,_selectedProps);
				function selectedProps (_props,_selectedProps) {
					for (var n = 0; n < _props.children.length; n++) {
						_selectedProps[_props.children[n].id] = _props.children[n].value;
					}
					return _selectedProps;
				} // END function selectedProps
								
				try {
					insertFontProps (_doc, _selectedRange, _selectedProps, _fillColorName.text, _strokeColorName.text, _boxStylesCheckbox.value);
				} catch (err) { 
					alert("Error\n" + err.message + "\nLine: " + err.line + "\nScript: " + err.fileName);
				}
				
				var _paletteProgressbarAlive = Window.find("palette", localize(_global.progressPaletteTitel));
				if (_paletteProgressbarAlive != null) {
					_paletteProgressbarAlive.close();
				}
			} else {
				alert (localize(_global.noDocumentOpenMessage));
			}
		}; // END _startButton.onClick

		_setupButton.addEventListener('click', function (_event) {
			var _userSettings = __getSettings(_fillColorName.text, _strokeColorName.text, _boxStylesCheckbox.value);
			_fillColorName.text = _userSettings[0] || "";
			_strokeColorName.text = _userSettings[1] || "";
			_boxStylesCheckbox.value = _userSettings[2] || false;
		});
		// END Callbacks
				
		return _win;
	} /* END function appliedFontPalette */
	
	
	function insertFontProps (_doc, _selectedRange, _selectedProps, _selectedFillColor, _selectedStrokeColor, _areBoxStylesUsed) {
		
		var _TSR = [];
		var _TSRInTables;
		var _TSRInFootnotes;

		switch (_selectedRange) {
			case 0 : /* Insertion point */
				if ((app.selection.length > 0) && (app.selection[0].hasOwnProperty("insertionPoints"))) { 
						if(app.selection[0].textStyleRanges.firstItem().isValid) {
							_TSR.push(app.selection[0].textStyleRanges.firstItem());
						} else {
							_TSR.push(app.selection[0].insertionPoints.firstItem());
						}
				} else {
					alert (localize(_global.noInsertionPointDetectableMessage));
					return;
				}
				break;
			case 1 : /* Stories */
				if (_doc.stories.firstItem().isValid == true) {
					_TSR = _doc.stories.everyItem().getElements();
				} else {
					alert(localize(_global.noStoryInDocumentMessage)); 
					return;
				}
				break;
			case 2 : /* Paragraphs */
				if (_doc.stories.firstItem().isValid == true) {
					_TSR = _doc.stories.everyItem().paragraphs.everyItem().getElements();
					if (_doc.stories.everyItem().tables.firstItem().isValid == true) {
						_TSRInTables = _doc.stories.everyItem().tables.everyItem().cells.everyItem().paragraphs.everyItem().getElements();
						_TSR = _TSR.concat(_TSRInTables);
					}
					if (_doc.stories.everyItem().footnotes.firstItem().isValid == true) {
						_TSRInFootnotes = _doc.stories.everyItem().footnotes.everyItem().paragraphs.everyItem().getElements();
						_TSR = _TSR.concat(_TSRInFootnotes);
					}
				} else {
					alert(localize(_global.noParagraphInDocumentMessage));
					return;
				} 
				break;
			case 3 : /* Text Style Ranges */
				if ((_doc.stories.firstItem().isValid == true) && (_doc.stories.everyItem().paragraphs.everyItem().textStyleRanges[0] != null)) {
					_TSR = _doc.stories.everyItem().paragraphs.everyItem().textStyleRanges.everyItem().getElements();
					if (_doc.stories.everyItem().tables.firstItem().isValid == true) {
						_TSRInTables = _doc.stories.everyItem().tables.everyItem().cells.everyItem().textStyleRanges.everyItem().getElements();
						_TSR = _TSR.concat(_TSRInTables);
					}
					if (_doc.stories.everyItem().footnotes.firstItem().isValid == true) {
						_TSRInFootnotes = _doc.stories.everyItem().footnotes.everyItem().textStyleRanges.everyItem().getElements();
						_TSR = _TSR.concat(_TSRInFootnotes);
					}
				} else {
					alert(localize(_global.noTextStyleRangeInDocumentMessage));
					return;
				}
				break;
			default:
				return;
		}
		
		var _fontFamily, _fontStyle, _fontColorName, _fontColorModel, _fontColorValues, _fontType, _pointSize, _leading, _kerning, _tracking, _horizontalScale, _verticalScale;
		var _capitalization, _noBreak, _skew, _appliedLanguage, _appliedPS, _appliedCS;
		var _parentTF;
		var _parentP;
		var _TFi;
		var _baselineTSRi;
		var _y1TFi, _x1TFi, _y2TFi, _x2TFi;
		var _y1Arrowi, _x1Arrowi, _y2Arrowi, _x2Arrowi;
		var _arrowi;
		var _noOverflow;
		var _fontDescriptionLayer;
		var _executionTime = 0;

		var _widthTFi = 70; // Breite eingefuegter Textrahmen
		var _heightTFi = 100; // Hoehe eingefuegter Textrahmen (vor der Anpassung durch das Skript)

		// Farben für Textrahmen und Pfeil
		var _fillColorSwatch;
		if(_selectedFillColor != null && _selectedFillColor != "") { 
			_fillColorSwatch = _doc.swatches.itemByName(_selectedFillColor);
			if(!_fillColorSwatch.isValid) {
				_fillColorSwatch = _doc.swatches[2];
			} 
		} else {
			_fillColorSwatch = _doc.swatches[2];
		}
		var _strokeColorSwatch;
		if(_selectedStrokeColor != null && _selectedStrokeColor != "") {
			_strokeColorSwatch = _doc.swatches.itemByName(_selectedStrokeColor);
			if(!_strokeColorSwatch.isValid) {
				_strokeColorSwatch = _doc.swatches[3];
			}
		} else {
			_strokeColorSwatch = _doc.swatches[3];
		}

		// Formate für Textrahmen und Pfeil
		var _boxPStyle;
		var _boxOStyle;
		var _arrowOStyle;
		if(_areBoxStylesUsed === true) {
			const _boxPStyleName = "which_font_is_it_box_paragraph";
			_boxPStyle = _doc.paragraphStyles.itemByName(_boxPStyleName);
			if(!_boxPStyle.isValid) {
				_boxPStyle = _doc.paragraphStyles.add({ name:_boxPStyleName });
			}
			const _boxOStyleName = "which_font_is_it_box";
			_boxOStyle = _doc.objectStyles.itemByName(_boxOStyleName);
			if(!_boxOStyle.isValid) {
				_boxOStyle = _doc.objectStyles.add({ name:_boxOStyleName });
			}
			_boxOStyle.textFramePreferences.ignoreWrap = true;
			_boxOStyle.fillColor = _fillColorSwatch;
			_boxOStyle.strokeColor = _strokeColorSwatch;
			_boxOStyle.strokeWeight = 2; 
			_boxOStyle.textFramePreferences.insetSpacing = [4,4,4,4];
			const _arrowOStyleName = "which_font_is_it_arrow";
			_arrowOStyle = _doc.objectStyles.itemByName(_arrowOStyleName);
			if(!_arrowOStyle.isValid) {
				_arrowOStyle = _doc.objectStyles.add({ name:_arrowOStyleName });
			}
			_arrowOStyle.strokeWeight = 2; 
			_arrowOStyle.arrowHeadAlignment = ArrowHeadAlignmentEnum.INSIDE_PATH;
			_arrowOStyle.strokeColor = _strokeColorSwatch; 
			_arrowOStyle.rightLineEnd = ArrowHead.TRIANGLE_ARROW_HEAD;
		} else {
			_boxPStyle = _doc.paragraphStyles.item(1); 
		}
		
		if (_doc.layers.itemByName("Which font is it?").isValid == false) {
			_fontDescriptionLayer = _doc.layers.add({ name:"Which font is it?" });
			_fontDescriptionLayer.move(LocationOptions.AT_BEGINNING);
			_fontDescriptionLayer.layerColor = UIColors.RED;
		} else {
			_fontDescriptionLayer = _doc.layers.itemByName("Which font is it?");
		}
	
		/* _TSR-Array in kleinere Einheiten aufsplitten */ 
		var _chunkSize = 10; /* Intervallgroesse */
		var _tsrChunks = __splitArray (_TSR,_chunkSize);
		
		/* Progressbar */
		var _paletteProgressCounter = new Window ("palette", localize(_global.progressPaletteTitel), undefined);
		var _progress = __progressCounter (_paletteProgressCounter, _tsrChunks.length);
		var _tsrChunksLength = _tsrChunks.length; 
		
		if(_chunkSize == 1 || _chunkSize == 0) { 
			var _progressCounterStart = _tsrChunks[0].length; 
	 	}
		
		for(var c=0; c<_tsrChunksLength; c++) { 
			_progress[0].text = _tsrChunksLength - c;
			var doScriptResult = app.doScript(__makeInfoBoxes, ScriptLanguage.JAVASCRIPT , _tsrChunks[c], UndoModes.ENTIRE_SCRIPT, "Make Infoboxes" );
			if(!doScriptResult) {
				break;
			}
		}
		
		_progress[0].parent.parent.close();
		
		function __progressCounter (_window, start) {
			
			var _time;
			var _chunkCounter;
			var _boxCounter;

			with(_window) {
				margins = [20,20,20,20];
				spacing = 10;
				_time = add("statictext");
				with(_time) {
					text = "Execution time: 0 s";
					characters = 25;
					justify = "center";
				} 
				var _counterPanel = add("panel");
				with(_counterPanel) {
					orientation = "row";
					_chunkCounter = add ("statictext");
					with (_chunkCounter) {
						text = start;
						characters = 5;
						justify = "center";
					} // END _chunkCounter 
					_boxCounter = add ("statictext");
					with (_boxCounter) {
						text = start;
						characters = 5;
						justify = "center";
					} // END _boxCounter
				} // END _counterPanel
				
			} // END _window

			if(_selectedRange !== 0) {
				_window.show ();
			}

			return [_chunkCounter,_boxCounter,_time];
		} // END function progressbar 


		function __splitArray (_array,_interval) {
					
				var _chunks = [], 
						_leftover = _array.length;
						
				if ( _array.length < _interval || _interval == 0 || _interval == 1) { 
					return [_array]; 
				}
				while (_leftover--) {
					_chunks[_chunks.length] = _array.splice(0, _interval);
					_leftover = _array.length;
				}
			return _chunks;
		} 
	 

		function __makeInfoBoxes (_TSR) {
					 
			var _horizontalMeasurementUnitsUser = _doc.viewPreferences.horizontalMeasurementUnits;
			var _verticalMeasurementUnitsUser = _doc.viewPreferences.verticalMeasurementUnits;

			_doc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.MILLIMETERS;
			_doc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.MILLIMETERS;
			
			var _goOn = true;
			
			try {
				
				var _tsrLength = _TSR.length;
				
				// Loop durch Formatbereiche
				for (var i=0; i<_tsrLength; i++) { 
					
					var _keyState = ScriptUI.environment.keyboardState;
					if(
						!!_keyState && !!_keyState.keyName && _keyState.keyName.constructor === String &&
						(_keyState.keyName.toLowerCase() === "escape" || _keyState.keyName.toLowerCase() == "esc")
					) {
						_goOn = false;
						break;
					} 

					_progress[1].text = _tsrLength - i; /* Zaehler TextStyleRanges */
					_executionTime += $.hiresTimer;
					_progress[2].text = "Execution time: " + Math.round(_executionTime/1000000) + " s"; /* Ausfuehrungszeit */
 
					var _output = [];
					var _text = _TSR[i];
					

					/* +++++++++++++++ */
					/* + START Props + */

					// Family
					if (_selectedProps["fontName"]) {
						if (_text.appliedFont.constructor.name == "Font") {
							_fontFamily = _text.appliedFont.fontFamily;
						} else {
							_fontFamily = _text.appliedFont;
						}
						_output.push (localize(_global.fontNameLabel) + ": " + _fontFamily);
					}
				
					//Style
					if (_selectedProps["fontStyle"]) {
						try {
							_fontStyle = _text.appliedFont.fontStyleName;
						} catch(e) {
							_fontStyle = _text.fontStyle;
						}
						_output.push (localize(_global.fontStyleLabel) + ": " + _fontStyle);
					}
				
					// Type
					if (_selectedProps["fontType"]) {
						try {
							switch (_text.appliedFont.fontType) {
									case FontTypes.ATC :
										_fontType = "ATC";
										break;
									case FontTypes.BITMAP :
										_fontType = "Bitmap";
										break;
									case FontTypes.CID :
										_fontType = "CID";
										break;
									case FontTypes.OCF :
										_fontType = "OCF";
										break;
									case FontTypes.OPENTYPE_CFF :
										_fontType = "OpenType CFF";
										break;
									case FontTypes.OPENTYPE_CID :
										_fontType = "OpenType CID";
										break;
									case FontTypes.OPENTYPE_TT :
										_fontType = "OpenType TT";
										break;
									case FontTypes.TRUETYPE :
										_fontType = "TrueType";
										break;
									case FontTypes.TYPE_1 :
										_fontType = "Type 1";
										break;
									default :
										_fontType = localize(_global.unknownLabel);
							}
						} catch (e) {
							_fontType = localize(_global.unknownLabel);
						}
						_output.push (localize(_global.fontTypeLabel) + ": " + _fontType);
					}
				
					// Size
					if (_selectedProps["fontSize"]) {
						_pointSize = localize(_global.fontSizeLabel) + ": " + _text.pointSize.toFixed(2) + " pt";
						_output.push (_pointSize);
					}
				
					// Leading
					if (_selectedProps["leading"]) {
						if (_text.leading == Leading.AUTO) {
							_leading = _text.pointSize*(_text.autoLeading/100);
							_leading = _leading.toFixed(2) + " pt";
						}
						else {
							_leading = _text.leading.toFixed(2) + " pt";
						}
						_output.push (localize(_global.leadingLabel) + ": " + _leading);
					}
				
					// Capitalization
					if (_selectedProps["caps"]) {
						switch (_text.capitalization) {
							case Capitalization.ALL_CAPS :
								_capitalization = localize(_global.allCapsLabel);
								break;
							case Capitalization.CAP_TO_SMALL_CAP :
								_capitalization = localize(_global.openTypeSmallCaps);
								break;
							case Capitalization.SMALL_CAPS :
								_capitalization = localize(_global.smallCapsLabel);
								break;
							default :
								_capitalization = localize(_global.normalCapsLabel);
						}
						_output.push (localize(_global.capsLabel) + ": " +_capitalization);
					}
				
					// Kerning
					if (_selectedProps["kerning"]) {
						_kerning = localize(_global.kerningLabel) + ": " + _text.kerningMethod;
						_output.push (_kerning);
					}
					
					// Tracking
					if (_selectedProps["tracking"]) {
						_tracking = localize(_global.trackingLabel) + ": " + _text.tracking;
						_output.push (_tracking);
					} 
					 
					// Scale
					if (_selectedProps["hScale"]) {
						_horizontalScale = localize(_global.hScaleLabel) + ": " + _text.horizontalScale + " %";
						_output.push (_horizontalScale);
					}
					if (_selectedProps["vScale"]) {
						_verticalScale = localize(_global.vScaleLabel) + ": " + _text.verticalScale + " %";
						_output.push (_verticalScale);
					}
					
					// Skew
					if (_selectedProps["skew"]) {
						_skew = localize(_global.skewLabel) + ": " + _text.skew + "°";
						_output.push (_skew);
					}

					// No Break
					if (_selectedProps["noBreak"]) {
						_noBreak = localize(_global.noBreakLabel) + ": " + _text.noBreak;
						_output.push (_noBreak);
					}
				
					// Color
					if (_selectedProps["color"]) {
									
						var _colorTint = "";
						var _colorName = ""; 
						var _colorModel = "";
						var _colorSpace = "";
						var _colorValue = "";
						var _colorValueString = "";
						var c;
						 
						if(_text.fillColor.isValid) {
							_colorName = _text.fillColor.name.toString();
							if(_text.fillColor.hasOwnProperty("model")) {
								_colorModel = _text.fillColor.model.toString();
								_colorModel = _colorModel.substring(0,1) + _colorModel.substring(1).toLowerCase();
							}
							if(_text.fillColor.hasOwnProperty("space")) {
								_colorSpace = _text.fillColor.space.toString();
							}
							if(_text.fillColor.hasOwnProperty("colorValue")) {
								_colorValue = _text.fillColor.colorValue;
								if(_colorValue instanceof Array) {
									for(c = 0; c < _colorValue.length; c++) {
										if(!isNaN(_colorValue[c])) {
											_colorValue[c] = Math.round(_colorValue[c]);
										}
									}
									_colorValueString = " (" +_colorValue.join (",") + ")";
								}
								
							}
						} 
						if(_text.fillTint != null && _text.fillTint != -1) {
								_colorTint = " " + _text.fillTint + " %";
						}
						
						_fontColorName = localize(_global.colorLabel) + ": " + _colorName + _colorTint;
						_output.push (_fontColorName);
						
						if(_text.fillColor.hasOwnProperty("model")) {
							_fontColorModel = localize(_global.colorLabel) + ": " + _colorModel;
							_output.push (_fontColorModel);
						}
								 
						_fontColorValues = localize(_global.colorLabel) + ": " + _colorSpace + _colorValueString;
						
						if(_colorSpace == "RGB") {
							 var _hexValue = __rgbToHex (_colorValue[0],_colorValue[1],_colorValue[2]);
							 _fontColorValues += " (#" + _hexValue + ")";
						}
						
						if(_text.fillColor.hasOwnProperty("space") && _text.fillColor.hasOwnProperty("colorValue")) {
							_output.push (_fontColorValues);
						}
					}
				
					function __rgbToHex (_red,_green,_blue) {
						
						var _hexRed = _red.toString(16),
								_hexGreen = _green.toString(16),
								_hexBlue = _blue.toString(16);
						
						if(_hexRed.length == 1) { _hexRed = "0" + _hexRed; }
						if(_hexGreen.length == 1) { _hexGreen = "0"+_hexGreen; }
						if(_hexBlue.length == 1) { _hexBlue = "0"+_hexBlue; }
						
						return _hexRed + _hexGreen + _hexBlue;
					} /* END function _rgbToHex */
					
					// Applied Style
					if (_selectedProps["pStyle"]) {
						_appliedPS = localize(_global.pStyleLabel) + ": " + _text.appliedParagraphStyle.name;
						_output.push (_appliedPS);
					}
					if (_selectedProps["cStyle"]) {
						_appliedCS = localize(_global.cStyleLabel) + ": " + _text.appliedCharacterStyle.name;
						_output.push (_appliedCS);
					}
					
					// Applied Language
					if (_selectedProps["language"]) {
						_appliedLanguage = localize(_global.languageLabel) + ": " + _text.appliedLanguage.name;
						_output.push (_appliedLanguage);
					}
					/* + END Props + */
					/* +++++++++++++ */
					

					// Abfrage Textueberlauf oder Objekt auf der Montageflaeache
					// Wenn nicht, Zuweisung parentPage und parentTextFrame
					switch (_text.constructor.name) {
							case "InsertionPoint" :
							case "TextStyleRange" :
							case "Paragraph" :
								// TF Overflow
								if ((_text.parentTextFrames[0]!=null)&&(_text.parentTextFrames[0].constructor.name != "TextPath")) {
									// Items on Pasteboard
									if (_text.parentTextFrames[0].parentPage != null) { 
										_parentP = _text.parentTextFrames[0].parentPage;
										_parentTF = _text.parentTextFrames[0];
										_noOverflow = true;
									} else {
										_noOverflow = false;
									}
								} else {
									_noOverflow = false;
								}
								break;
							case "Story" :
								// TF Overflow
								if ((_text.insertionPoints[0].parentTextFrames[0]!=null)&&(_text.insertionPoints[0].parentTextFrames[0].constructor.name != "TextPath")) {
									// Items on Pasteboard
									if (_text.insertionPoints[0].parentTextFrames[0].parentPage != null) { 
											_parentP = _text.insertionPoints[0].parentTextFrames[0].parentPage;
											_parentTF = _text.insertionPoints[0].parentTextFrames[0];
											_noOverflow = true;
									} else {
										_noOverflow = false;
									}
								} else {
									_noOverflow = false;
								} 
								break;
							default :
								_noOverflow = false;
					}
								
					if (_noOverflow) {
						
						/* Font Info Box */
						_TFi = _parentP.textFrames.add(_fontDescriptionLayer, { name:"Description " + i });
						_TFi.textFramePreferences.ignoreWrap = true;
						_TFi.fillColor = _fillColorSwatch;
						_TFi.strokeColor = _strokeColorSwatch;
						_TFi.strokeWeight = 2; 
						_baselineTSRi = _text.lines[0].baseline;
							
						_y1TFi = _baselineTSRi;
						_x1TFi = _parentTF.geometricBounds[1]-_widthTFi;
						_y2TFi = _baselineTSRi+_heightTFi;
						_x2TFi = _parentTF.geometricBounds[1]-10;
							
						_TFi.geometricBounds = [_y1TFi,_x1TFi,_y2TFi,_x2TFi];
						_TFi.textFramePreferences.insetSpacing = [4,4,4,4];

						for (var j=0; j<_output.length; j++) {
							_TFi.insertionPoints[-1].contents = _output[j] + "\r";
							if (_TFi.paragraphs.item(j).isValid) {
								_TFi.paragraphs.item(j).applyParagraphStyle(_boxPStyle);
								_TFi.paragraphs.item(j).clearOverrides(OverrideType.ALL);
							}
						}
						
						_TFi.geometricBounds = [_y1TFi,_x1TFi,_TFi.lines[-1].baseline+_TFi.textFramePreferences.insetSpacing[2]+_TFi.strokeWeight,_x2TFi];
						if(!!_boxOStyle && _boxOStyle.isValid) {
							_TFi.applyObjectStyle(_boxOStyle);
							_TFi.clearObjectStyleOverrides();
						}

						/* Arrow */
						_y1Arrowi = _baselineTSRi;
						_x1Arrowi = _TFi.geometricBounds[3];
						_y2Arrowi = _baselineTSRi;
						_x2Arrowi = _text.insertionPoints[0].horizontalOffset;
						_arrowi = _parentP.graphicLines.add(_fontDescriptionLayer, {
							name:"Arrow "+i, 
							strokeWeight:2, 
							arrowHeadAlignment: ArrowHeadAlignmentEnum.INSIDE_PATH,
							strokeColor: _strokeColorSwatch, 
							rightLineEnd: ArrowHead.TRIANGLE_ARROW_HEAD, 
							geometricBounds: [_y1Arrowi, _x1Arrowi, _y2Arrowi, _x2Arrowi]
						});
						if(!!_arrowOStyle && _arrowOStyle.isValid) {
							_arrowi.applyObjectStyle(_arrowOStyle);
							_arrowi.clearObjectStyleOverrides();
						}

						_parentP.groups.add([_TFi,_arrowi],_fontDescriptionLayer, {
							name:"Group "+i
						});
							
					} /*else { 
						alert("Uebersatztext in einem der Textrahmen oder Text auf Montageflaeche!");
					} */
				} // END loop TSR-Array
			} catch (err) {
				alert("Error\n" + err.message + "\nLine: " + err.line + "\nScript: " + err.fileName );
				_goOn = false;
			} finally {
				_doc.viewPreferences.horizontalMeasurementUnits = _horizontalMeasurementUnitsUser;
				_doc.viewPreferences.verticalMeasurementUnits = _verticalMeasurementUnitsUser;
			}
		
			if(!_goOn) {
				return null;
			}

			return _TSR;
		} // END funktion __makeInfoBox
	} /* END function insertFontProps */
} /* END function main */


function __getSettings(_fillColorName, _strokeColorName, _areBoxStylesUsed) {
	
	var _output = ["","", false];

	if(app.documents.length === 0 || app.layoutWindows.length === 0) { 
		return _output; 
	}
	
	var _doc = app.activeDocument;
	var _swatchList = _doc.swatches.everyItem().name;
	var _fillColor;
	var _strokeColor;
	
	var _fillColorSwatchDropdown;
	var _strokeColorSwatchDropdown;
	var _boxStylesCheckbox;
	var _uiResponse;
	
	var _colorSelectionUI = new Window ("dialog", localize(_global.setupDialogTitel));
	with(_colorSelectionUI) { 
		alignChildren = "right";
		spacing = 5;
		var _fillColorGroup = add("group");
		with(_fillColorGroup) {
			spacing = 5;
			add("statictext", undefined, localize(_global.fillColorLabel));
			_fillColorSwatchDropdown = add ("dropdownlist", undefined, _swatchList);
			with(_fillColorSwatchDropdown) {
				selection = 2;
			} /* END _fillColorSwatchDropdown */
		} /* END _fillColorGroup */
		var _strokeColorGroup = add("group");
		with(_strokeColorGroup) {
			spacing = 5;
			add("statictext", undefined, localize(_global.strokeColorLabel));
			_strokeColorSwatchDropdown = add ("dropdownlist", undefined, _swatchList);
			with(_strokeColorSwatchDropdown) {
				selection = 3;
			} /* END _strokeColorSwatchDropdown */
		} /* END _strokeColorGroup */
		var _stylesCheckboxGroup = add("group");
		with(_stylesCheckboxGroup) {
			margins.top = 10;
			_boxStylesCheckbox = add("checkbox", undefined, localize(_global.stylesCheckboxLabel));
		} /* END _stylesCheckboxGroup */
		var _actionButtonGroup = add ("group");
		with (_actionButtonGroup) {
			orientation = "row";
			margins.top = 20;
			var _cancelButton = add ("button", undefined, localize(_global.settingsCancelButtonLabel), { name: "cancel" });
			var _startButton = add ("button", undefined, localize(_global.settingsOkButtonLabel), { name: "ok" });
		} /* END _actionButtonGroup */
	} /* END _colorSelectionUI */

	/* Init */
	var _fillColorItem = _fillColorSwatchDropdown.find(_fillColorName);
	if(_fillColorItem !== null) {
		_fillColorSwatchDropdown.selection = _fillColorItem.index;
	}
	var _strokeColorItem = _strokeColorSwatchDropdown.find(_strokeColorName);
	if(_strokeColorItem !== null) {
		_strokeColorSwatchDropdown.selection = _strokeColorItem.index;
	}
	_boxStylesCheckbox.value = _areBoxStylesUsed;

	/* Show setup dialog */
	_uiResponse = _colorSelectionUI.show ();
	
	if (_uiResponse !==1) { 
		return _output; 
	}
		
	_fillColor = _doc.swatches.itemByName(_fillColorSwatchDropdown.selection.text);
	_strokeColor = _doc.swatches.itemByName(_strokeColorSwatchDropdown.selection.text);
	
	if(_fillColor.isValid) {
		_output[0] = _fillColor.name;
	} 

	if(_strokeColor.isValid) {
		_output[1] = _strokeColor.name;
	}

	_output[2] = _boxStylesCheckbox.value;

	return _output;
} /* END function __getSettings */


/* Deutsch-Englische Dialogtexte definieren */
function __defLocalizeStrings() {
	
	if(!_global) { 
		return false; 
	}

	_global.noDocOpenAlert = { 
		en:"A document must be open to execute the script!",
		de:"F\u00FCr die Ausf\u00FChrung des Skriptes ist ein ge\u00F6ffnetes Dokument erforderlich!" 
	};
	
	_global.goBackLabel = { 
		en:"Go back label",
		de:"Go back label" 
	};
	
	_global.processingErrorAlert = { 
		en:"Error processing the document!",
		de:"Fehler bei der Verarbeitung des Dokuments!" 
	};

	_global.errorMessageLabel = { 
		en:"Error message:",
		de:"Fehlermeldung:" 
	};

	_global.lineLabel = { 
		en:"Line:",
		de:"Zeile:" 
	};
	
	_global.logDialogTitle = { 
		en: "Messages",
		de: "Meldungen" 
	};
	
	_global.okButtonLabel = { 
		en: "OK",
		de: "OK" 
	};
	
	_global.dialogTitle = { 
		en: "What font is it",
		de: "What font is it" 
	};
	
	_global.rangePaletteLabel = { 
		en: "Look for",
		de: "Suche nach" 
	};
	
	_global.textStyleRangesRadiobuttonLabel = { 
		en: "Style Ranges",
		de: "Formatbereiche" 
	};
	
	_global.paragraphsRadiobuttonLabel = { 
		en: "Paragraphs",
		de: "Absätze" 
	};

	_global.storiesRadiobuttonLabel = { 
		en: "Storys",
		de: "Textabschnitte" 
	};

	_global.insertionPointsRadiobuttonLabel = { 
		en: "Insertion Point",
		de: "Einfügemarke" 
	};

	_global.propertiesPaletteLabel = { 
		en: "Listed Properties",
		de: "Eigenschaften" 
	};

	_global.fontNameCheckboxLabel = { 
		en: "Font Name",
		de: "Schriftname" 
	};

	_global.fontStyleCheckboxLabel = { 
		en: "Font Style",
		de: "Schriftschnitt" 
	};

	_global.fontTypeCheckboxLabel = { 
		en: "Font Type",
		de: "Schrifttyp" 
	};

	_global.fontSizeCheckboxLabel = { 
		en: "Font Size",
		de: "Schriftgrad" 
	};

	_global.leadingCheckboxLabel = { 
		en: "Leading",
		de: "Zeilenabstand" 
	};

	_global.capsCheckboxLabel = { 
		en: "Capitalization",
		de: "Kapitälchen" 
	};

	_global.kerningCheckboxLabel = { 
		en: "Kerning Method",
		de: "Kerning Methode" 
	};

	_global.trackingCheckboxLabel = { 
		en: "Tracking",
		de: "Laufweite" 
	};

	_global.hScaleCheckboxLabel = { 
		en: "Horizontal Scale",
		de: "Horizontale Skalierung" 
	};

	_global.vScaleCheckboxLabel = { 
		en: "Vertical Scale",
		de: "Vertikale Skalierung" 
	};

	_global.skewCheckboxLabel = { 
		en: "Skew",
		de: "Neigung" 
	};

	_global.noBreakCheckboxLabel = { 
		en: "No Break",
		de: "Kein Umbruch" 
	};

	_global.colorCheckboxLabel = { 
		en: "Color",
		de: "Schriftfarbe" 
	};

	_global.pStyleCheckboxLabel = { 
		en: "Paragraph Style",
		de: "Absatzformat" 
	};

	_global.cStyleCheckboxLabel = { 
		en: "Character Style",
		de: "Zeichenformat" 
	};

	_global.languageCheckboxLabel = { 
		en: "Language",
		de: "Sprache" 
	};

	_global.escStopLabel = { 
		en: "Stop with ESC",
		de: "Stopp mit ESC" 
	};

	_global.startButtonLabel = { 
		en: "Start",
		de: "Start" 
	};

	_global.boxStyleCheckboxLabel = { 
		en: "Use font box styles",
		de: "Formate für Schriftbox" 
	};

	_global.fontNameLabel = { 
		en: "Font Name",
		de: "Schriftname" 
	};

	_global.fontStyleLabel = { 
		en: "Font Style",
		de: "Schriftschnitt" 
	};

	_global.fontTypeLabel = { 
		en: "Font Type",
		de: "Schrifttyp" 
	};

	_global.fontSizeLabel = { 
		en: "Font Size",
		de: "Schriftgrad" 
	};

	_global.leadingLabel = { 
		en: "Leading",
		de: "Zeilenabstand" 
	};

	_global.capsLabel = { 
		en: "Caps",
		de: "Kapitälchen" 
	};

	_global.allCapsLabel = { 
		en: "All uppercase",
		de: "Großbuchstaben" 
	};

	_global.openTypeSmallCaps = { 
		en: "OpenType small caps",
		de: "OpenType-Kapitälchen" 
	};
	_global.smallCapsLabel = { 
		en: "Small caps for lowercase",
		de: "Kapitälchen" 
	};
	_global.normalCapsLabel = { 
		en: "Normal",
		de: "Normal" 
	};

	_global.kerningLabel = { 
		en: "Kerning",
		de: "Kerning" 
	};

	_global.trackingLabel = { 
		en: "Tracking",
		de: "Laufweite" 
	};

	_global.hScaleLabel = { 
		en: "Horizontal Scale",
		de: "x-Skalierung" 
	};

	_global.vScaleLabel = { 
		en: "Vertical Scale",
		de: "y-Skalierung" 
	};

	_global.skewLabel = { 
		en: "Skew",
		de: "Neigung" 
	};

	_global.noBreakLabel = { 
		en: "No Break",
		de: "Kein Umbruch" 
	};

	_global.colorLabel = { 
		en: "Color",
		de: "Farbe" 
	};

	_global.pStyleLabel = { 
		en: "Paragraph Style",
		de: "Absatzformat" 
	};

	_global.cStyleLabel = { 
		en: "Character Style",
		de: "Zeichenformat" 
	};

	_global.languageLabel = { 
		en: "Language",
		de: "Sprache" 
	};

	_global.unknownLabel = { 
		en: "unknown",
		de: "unbekannt" 
	};

	_global.noLabel = { 
		en: "no",
		de: "nein" 
	};

	_global.yesLabel = { 
		en: "yes",
		de: "ja" 
	};

	_global.noInsertionPointDetectableMessage = { 
		en: "No insertion point detectable!",
		de: "Kein Einfügepunkt ermittelbar!" 
	};

	_global.noStoryInDocumentMessage = { 
		en: "No story in the Document!",
		de: "Kein Textabschnitt im Dokument vorhanden!" 
	};

	_global.noParagraphInDocumentMessage = { 
		en: "No paragraph in the Document!",
		de: "Kein Absatz im Dokument vorhanden!" 
	};

	_global.noTextStyleRangeInDocumentMessage = { 
		en: "No style ranges in the Document!",
		de: "Kein Formatbereich im Dokument vorhanden!" 
	};

	_global.progressPaletteTitel = { 
		en: "Progress",
		de: "Fortschritt" 
	};

	_global.noDocumentOpenMessage = { 
		en: "No document opened!",
		de: "Kein Dokument geöffnet!" 
	};

	_global.setupDialogTitel = { 
		en: "Setup",
		de: "Einstellungen" 
	};

	_global.fillColorLabel = { 
		en: "Fill Color:",
		de: "Flächenfarbe:" 
	};

	_global.strokeColorLabel = { 
		en: "Stroke Color:",
		de: "Konturfarbe:" 
	};

	_global.stylesCheckboxLabel = { 
		en: "Styles for font info boxes",
		de: "Formate für Info-Boxen zuweisen" 
	};

	_global.settingsCancelButtonLabel = { 
		en: "Cancel",
		de: "Abbrechen" 
	};

	_global.settingsOkButtonLabel = { 
		en: "OK",
		de: "OK" 
	};

} /* END function __defLocalizeStrings */